#pragma once

#include <avr/pgmspace.h> 
#include "constants.h"

// === bitmaps ===

// Submarine.png / 13x7
PROGMEM const unsigned char bitmapSubmarine[] = {
  13, 7,
  0x14, 0x2C, 0x16, 0x56, 0x44, 0x57, 0x77, 0x55, 0x24, 0x2C, 
  0x1E, 0x3C, 0x1C
};

// Torpedo.png / 10x3
PROGMEM const unsigned char bitmapTorpedo[] = {
  10, 3,
  0x02, 0x00, 0x07, 0x02, 0x02, 0x02, 0x02, 0x02, 0x07, 0x02
};

// Shockwave0.png / 3x9
PROGMEM const unsigned char bitmapShockwave0[] = {
  3, 9,
  0x28, 0xC6, 0x38, 0x00, 0x00, 0x00
};

// Shockwave1.png / 3x9
PROGMEM const unsigned char bitmapShockwave1[] = {
  3, 9,
  0x44, 0x83, 0x7C, 0x00, 0x01, 0x00
};

// Shockwave2.png / 3x9
PROGMEM const unsigned char bitmapShockwave2[] = {
  3, 9,
  0x44, 0x01, 0x44, 0x00, 0x01, 0x00
};

// AutoShot.png / 6x3
PROGMEM const unsigned char bitmapAutoShot[] = {
  6, 3,
  0x05, 0x00, 0x05, 0x05, 0x05, 0x05
};

// CruEnemy0.png / 26x10
PROGMEM const unsigned char bitmapCruEnemy0[] = {
  26, 10,
  0xC0, 0x60, 0x68, 0xF8, 0xB8, 0x3C, 0xF8, 0x7E, 0xF8, 0xFF, 
  0xFF, 0xFE, 0xF8, 0x7E, 0xFC, 0xF0, 0x38, 0xF8, 0x30, 0xF8, 
  0xB8, 0x70, 0x38, 0x38, 0x70, 0xE0, 0x00, 0x01, 0x00, 0x02, 
  0x03, 0x01, 0x01, 0x00, 0x01, 0x03, 0x02, 0x01, 0x01, 0x02, 
  0x03, 0x00, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x01, 0x00
};

// TriEnemy0.png / 8x8
PROGMEM const unsigned char bitmapTriEnemy0[] = {
  8, 8,
  0x08, 0x18, 0x3C, 0x6E, 0x6E, 0xFF, 0xFF, 0x24
};

// TriEnemy1.png / 8x8
PROGMEM const unsigned char bitmapTriEnemy1[] = {
  8, 8,
  0x04, 0x4C, 0x64, 0x1A, 0x5A, 0x46, 0xEF, 0xC3
};

// BoostEffect.png / 5x4
PROGMEM const unsigned char bitmapBoostEffect[] = {
  5, 4,
  0x09, 0x09, 0x09, 0x00, 0x09
};

// ZigEnemy0.png / 9x7
PROGMEM const unsigned char bitmapZigEnemy0[] = {
  9, 7,
  0x60, 0x38, 0x2C, 0x74, 0x3E, 0x7E, 0x1F, 0x28, 0x04
};

// ZigEnemy1.png / 9x7
PROGMEM const unsigned char bitmapZigEnemy1[] = {
  9, 7,
  0x02, 0x02, 0x0B, 0x63, 0x25, 0x4A, 0x2E, 0x5C, 0x2C
};

// Mbullet0.png / 7x7
PROGMEM const unsigned char bitmapMbullet0[] = {
  7, 7,
  0x1C, 0x22, 0x5D, 0x5D, 0x5D, 0x22, 0x1C
};

// Mbullet1.png / 7x7
PROGMEM const unsigned char bitmapMbullet1[] = {
  7, 7,
  0x00, 0x1C, 0x3E, 0x3E, 0x3E, 0x1C, 0x00
};

// Sbullet0.png / 4x4
PROGMEM const unsigned char bitmapSbullet0[] = {
  4, 4,
  0x06, 0x09, 0x09, 0x06
};

// Sbullet1.png / 4x4
PROGMEM const unsigned char bitmapSbullet1[] = {
  4, 4,
  0x00, 0x06, 0x06, 0x00
};

// Explosion0.png / 12x12
PROGMEM const unsigned char bitmapExplosion0[] = {
  12, 12,
  0x00, 0x00, 0x00, 0x40, 0x60, 0xF8, 0xF0, 0x60, 0x20, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 
  0x00, 0x00, 0x00, 0x00
};

// Explosion1.png / 12x12
PROGMEM const unsigned char bitmapExplosion1[] = {
  12, 12,
  0x40, 0x40, 0xE4, 0xA8, 0x1C, 0x8F, 0x00, 0x2C, 0x08, 0x38, 
  0xE4, 0x40, 0x00, 0x02, 0x00, 0x01, 0x0E, 0x04, 0x02, 0x06, 
  0x00, 0x03, 0x04, 0x00
};

// Explosion2.png / 12x12
PROGMEM const unsigned char bitmapExplosion2[] = {
  12, 12,
  0xE4, 0x72, 0xC0, 0xF6, 0xFB, 0xFD, 0xFD, 0xF8, 0xFA, 0xEE, 
  0x9C, 0xC0, 0x00, 0x01, 0x02, 0x00, 0x05, 0x0F, 0x0B, 0x0B, 
  0x01, 0x04, 0x03, 0x01
};

// Ten.png / 5x4
PROGMEM const unsigned char bitmapTen[] = {
  5, 4,
  0x0F, 0x00, 0x0F, 0x09, 0x0F
};

// ExtraLives.png / 9x3
PROGMEM const unsigned char bitmapExtraLives[] = {
  9, 3,
  0x02, 0x06, 0x07, 0x06, 0x06, 0x00, 0x05, 0x02, 0x05
};

// Wave.png / 64x4
PROGMEM const unsigned char bitmapWave[] = {
  64, 4,
  0x04, 0x04, 0x08, 0x08, 0x08, 0x04, 0x04, 0x02, 0x01, 0x02, 
  0x04, 0x04, 0x08, 0x08, 0x04, 0x04, 0x02, 0x04, 0x04, 0x08, 
  0x08, 0x08, 0x04, 0x04, 0x04, 0x04, 0x04, 0x08, 0x08, 0x04, 
  0x04, 0x02, 0x01, 0x02, 0x04, 0x04, 0x08, 0x08, 0x08, 0x04, 
  0x04, 0x04, 0x08, 0x08, 0x08, 0x08, 0x04, 0x04, 0x04, 0x04, 
  0x04, 0x08, 0x08, 0x08, 0x04, 0x04, 0x02, 0x04, 0x04, 0x08, 
  0x08, 0x08, 0x08, 0x04
};

// Bottom.png / 80x4
PROGMEM const unsigned char bitmapBottom[] = {
  80, 4,
  0x08, 0x0C, 0x0F, 0x0F, 0x0E, 0x0C, 0x0C, 0x0C, 0x08, 0x08, 
  0x08, 0x0C, 0x0E, 0x0E, 0x0C, 0x0C, 0x0C, 0x0E, 0x0C, 0x08, 
  0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x0C, 0x08, 0x0C, 0x0C, 
  0x08, 0x08, 0x08, 0x08, 0x0C, 0x0C, 0x0E, 0x0E, 0x0E, 0x0E, 
  0x0C, 0x0C, 0x08, 0x08, 0x0C, 0x0C, 0x08, 0x08, 0x08, 0x08, 
  0x08, 0x0C, 0x0C, 0x0E, 0x0E, 0x0D, 0x08, 0x08, 0x0A, 0x0E, 
  0x0C, 0x0C, 0x08, 0x08, 0x08, 0x0C, 0x0C, 0x08, 0x08, 0x08, 
  0x08, 0x08, 0x08, 0x0C, 0x0C, 0x0E, 0x0C, 0x08, 0x08, 0x08
};

// Logo.png / 48x38
PROGMEM const unsigned char bitmapLogo[] = {
  48, 38,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x80, 0x60, 0x18, 0x87, 0xC1, 0x31, 0x0A, 0x0E, 0x08, 
  0x08, 0x08, 0x08, 0x18, 0x38, 0xF8, 0xF8, 0xF8, 0xF8, 0x38, 
  0x18, 0x08, 0x08, 0x0C, 0xF2, 0x02, 0x02, 0xF4, 0x08, 0x00, 
  0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x60, 0x38, 0xFE, 0x07, 
  0x0C, 0xD2, 0x21, 0x00, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 
  0x04, 0x04, 0x04, 0xFF, 0xFF, 0xFF, 0xFF, 0x04, 0x04, 0x04, 
  0x04, 0x04, 0xFF, 0x00, 0x00, 0xFF, 0x06, 0x05, 0x04, 0x05, 
  0x06, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x04, 0x03, 0x01, 0x00, 0x00, 0xFF, 0x00, 0x00, 0xFF, 
  0x00, 0x00, 0x00, 0x00, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 
  0x02, 0xFF, 0xFF, 0xFF, 0xFF, 0x02, 0x02, 0x02, 0x02, 0x02, 
  0x07, 0x04, 0x02, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x3F, 0x20, 0x10, 0x0F, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x20, 0x20, 0x20, 0x30, 0x38, 0x3F, 
  0x3F, 0x3F, 0x3F, 0x38, 0x30, 0x20, 0x20, 0x20, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x08, 0x3E, 0x0A, 0x00, 0x38, 0x28, 0x38, 
  0x00, 0x38, 0x10, 0x08, 0x00, 0x00, 0x3C, 0x12, 0x12, 0x3C, 
  0x00, 0x3E, 0x0A, 0x1A, 0x24, 0x00, 0x3E, 0x22, 0x22, 0x1C, 
  0x00, 0x1E, 0x20, 0x20, 0x1E, 0x00, 0x3E, 0x2A, 0x2A, 0x14, 
  0x00, 0x1C, 0x22, 0x22, 0x1C, 0x00, 0x0E, 0x38, 0x38, 0x0E
};

// Ok.png / 5x7
PROGMEM const unsigned char bitmapOk[] = {
  5, 7,
  0x07, 0x05, 0x77, 0x20, 0x50
};

// Circle.png / 11x11
#ifndef LOW_FLASH_MEMORY
PROGMEM const unsigned char bitmapCircle[] = {
  11, 11,
  0x70, 0x8c, 0x02, 0x02, 0x01, 0x01, 0x01, 0x02, 0x02, 0x8c,
  0x70, 0x00, 0x01, 0x02, 0x02, 0x04, 0x04, 0x04, 0x02, 0x02,
  0x01, 0x00
};
#endif

// === sound scores ===

#ifndef DISABLE_MUSIC
// Playtune bytestream for file "arduboy_i_half.mid" created by MIDITONES V1.6 on Wed Nov 11 23:07:29 2015
// command line: miditones32.exe arduboy_i_half -t2 
PROGMEM const byte music [] = {
  0x90,67, 1,109, 0x80, 0x90,74, 1,109, 0x80, 0x90,74, 1,109, 0x80, 0x90,72, 0,182, 
  0x80, 0x90,74, 1,109, 0x80, 0x90,74, 1,109, 0x80, 0x90,77, 1,109, 0x80, 0x90,74, 0,182, 0x80, 
  0x90,72, 0,182, 0x80, 0x90,74, 0,182, 0x80, 0x90,72, 1,109, 0x80, 0x90,53, 1,109, 0x80, 0x90,60, 
  1,109, 0x80, 0x90,58, 0,182, 0x80, 0x90,57, 1,109, 0x80, 0x90,58, 1,109, 0x80, 0x90,57, 1,109, 
  0x80, 0x90,53, 1,109, 0x80, 0x90,57, 0,182, 0x80, 0x90,67, 1,109, 0x80, 0x90,74, 1,109, 0x80, 
  0x90,74, 1,109, 0x80, 0x90,72, 0,182, 0x80, 0x90,74, 1,109, 0x80, 0x90,74, 1,109, 0x80, 0x90,82, 
  1,109, 0x80, 0x90,79, 0,182, 0x80, 0x90,77, 0,182, 0x80, 0x90,79, 0,182, 0x80, 0x90,77, 1,109, 
  0x80, 0x90,53, 1,109, 0x80, 0x90,50, 1,109, 0x80, 0x90,48, 0,182, 0x80, 0x90,50, 1,109, 0x80, 
  0x90,53, 1,109, 0x80, 0x90,57, 1,109, 0x80, 0x90,53, 1,109, 0x80, 0x90,57, 0,182, 0x80, 0x90,67, 
  1,109, 0x80, 0x90,74, 1,109, 0x80, 0x90,74, 1,109, 0x80, 0x90,72, 0,182, 0x80, 0x90,74, 1,109, 
  0x80, 0x90,74, 1,109, 0x80, 0x90,77, 1,109, 0x80, 0x90,74, 0,182, 0x80, 0x90,72, 0,182, 0x80, 
  0x90,74, 0,182, 0x80, 0x90,72, 1,109, 0x80, 0x90,53, 1,109, 0x80, 0x90,60, 1,109, 0x80, 0x90,58, 
  0,182, 0x80, 0x90,60, 1,109, 0x80, 0x90,62, 1,109, 0x80, 0x90,57, 1,109, 0x80, 0x90,53, 1,109, 
  0x80, 0x90,57, 0,182, 0x80, 0x90,63, 1,109, 0x80, 0x90,70, 1,109, 0x80, 0x90,70, 1,109, 0x80, 
  0x90,69, 0,182, 0x80, 0x90,70, 1,109, 0x80, 0x90,70, 1,109, 0x80, 0x90,74, 1,109, 0x80, 0x90,70, 
  0,182, 0x80, 0x90,69, 0,182, 0x80, 0x90,70, 0,182, 0x80, 0x90,72, 1,109, 0x80, 0x90,53, 1,109, 
  0x80, 0x90,50, 1,109, 0x80, 0x90,48, 0,182, 0x80, 0x90,50, 1,109, 0x80, 0x90,53, 1,109, 0x80, 
  0x90,57, 1,109, 0x80, 0x90,58, 1,109, 0x80, 0x90,57, 0,182, 0x80, 0xf0
};
// This score contains 382 bytes, and 1 tone generator is used.
#endif

